﻿using Action = TreeSharp.Action;
using Levelbot.Actions.Combat;
using Levelbot.Actions.Death;
using Sequence = TreeSharp.Sequence;
using Styx.Combat.CombatRoutine;
using Styx.Helpers;
using Styx.Logic.BehaviorTree;
using Styx.Logic.Combat;
using Styx.Logic.Inventory.Frames.LootFrame;
using Styx.Logic.Pathing;
using Styx.Logic.POI;
using Styx.Logic;
using Styx.Patchables;
using Styx.Plugins.PluginClass;
using Styx.Plugins;
using Styx.WoWInternals.WoWObjects;
using Styx.WoWInternals;
using Styx;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System;
using TreeSharp;


namespace Styx.Bot.CustomBots
{
    public class MBoxFollower : BotBase
    {
        // ********************** Pet Target Enable/Disable *************************
        private bool pettarget = true; // Use leaders pet's target when leader has no target
        private bool lootinside = true; // Loot when inside buildings
        private bool lootininstance = false; // Loot when in an instance
        private bool lootatall = true; // Loot at all
        private bool Skinning = true; // Enable skinning?
        private bool NinjaSkin = false; // Skin other peoples kills
        private bool AutoQuestItem = true; // Look for quest items on the ground, such as flowers and whatnot
        private int DistanceForQuestItem = 10; // How far to search for quest items
        private bool ManualLeader = false; // If true, target the person you want to be leader, then hit start
        private int distance_to_follow = 5; // How close to follow the leader, this is in feet
        private bool AutoTargetQG = true; //Auto Target RaF Leader's target is they have a quest you can pick up or turn in. (Will not turn in or pick upquest automatically)
        // ********************** Do not edit anything below this line **************

        #region Overrides of BotBase

        public override string Name
        {
            get { return string.Format("Multibox Follower"); }
        }

        private Composite _root;
        public override Composite Root
        {
            get
            {
                return _root ?? (_root =
                    new PrioritySelector(
                        CreateCombatBehavior()
                        )
                    );
            }
        }

        public override PulseFlags PulseFlags
        {
            get { return PulseFlags.All; }
        }

        public override void Start()
        {
            Targeting.Instance.IncludeTargetsFilter += IncludeTargetsFilter;
            StyxSettings.Instance.LogoutForInactivity = false;
        }

        public override void Stop()
        {
            Targeting.Instance.IncludeTargetsFilter -= IncludeTargetsFilter;
            StyxSettings.Instance.LogoutForInactivity = true;
        }

        #endregion

        #region Targeting Filter

        private static void IncludeTargetsFilter(List<WoWObject> incomingUnits, HashSet<WoWObject> outgoingUnits)
        {
            if (StyxWoW.Me.GotTarget && StyxWoW.Me.CurrentTarget.Attackable)
            {
                outgoingUnits.Add(StyxWoW.Me.CurrentTarget);
            }
        }

        #endregion

        #region Follower Code
        private bool FirstPulse = true;
        private bool islooting = false;
        private bool verann = false;
        private string mycorpse = null;
        public readonly LocalPlayer Me = ObjectManager.Me;
        private List<WoWUnit> LootBlacklist;
        private List<WoWUnit> LootList;
        private List<WoWUnit> SkinList;
        private List<WoWGameObject> QuestItems;
        private bool ManLeadFound = false;
        private bool QuestGiverTargeted = false;
        private WoWPlayer Leader;

        //public readonly WoWPlayer Leader = ObjectManager.Me.CurrentTarget;
        private void slog(string format, params object[] args)
        {
            Logging.Write("[MBoxFollower] " + format, args);
        }


        private static Stopwatch lootTimer = new Stopwatch();

        //Loot routine
        #region Loot code

        private void Loot()
        {
            //try
            {
                #region Loot Ground Quest items
                if (AutoQuestItem && LootList.Count == 0)
                {
                    QuestItems = ObjectManager.GetObjectsOfType<WoWGameObject>()
            .Where(o => (o.SubType == WoWGameObjectType.Chest || o.SubType == WoWGameObjectType.Goober) && o.CanLoot && o.Distance <= DistanceForQuestItem && !o.IsChest && !o.IsHerb && !o.IsMineral)
            .OrderBy(o => o.Distance).ToList();
                    
                    foreach (WoWGameObject QuestItem in QuestItems)
                    {
                        if (QuestItems.Count >= 1)
                        {
                            if (QuestItems[0].WithinInteractRange)
                            {
                                WoWMovement.MoveStop();
                                TreeRoot.StatusText = "Looting quest item " + QuestItems[0].Name;
                                QuestItems[0].Interact();
                                Styx.Logic.Inventory.Frames.LootFrame.LootFrame.Instance.LootAll();

                            }
                            else
                            {
                                Navigator.MoveTo(QuestItems[0].WorldLocation);
                                TreeRoot.StatusText = "Found quest item " + QuestItems[0].Name + ", going to loot it";                            }
                        }
                    }
                }

                #endregion


                if (lootatall)
                {
                    #region Loot Skinable objects
                    if (Skinning)
                    {
                        foreach (WoWUnit Skinable in SkinList)
                        {
                            //if (LootBlacklist.Contains(Lootable))
                            //{
                            //    Me.ClearTarget();
                            //    Thread.Sleep(500);
                            //}
                            if (Me.CurrentTarget == null)
                            {
                                Skinable.Target();
                                Thread.Sleep(500);
                            }
                            else if ((Me.CanSkinLevel >= Me.CurrentTarget.Level && Me.CurrentTarget.CanSkin || Me.CurrentTarget.CanLoot) && Me.CurrentTarget.Dead)
                            {
                                if (Me.CurrentTarget.WithinInteractRange)
                                {
                                    lootTimer.Start();

                                    WoWMovement.MoveStop();
                                    WoWMovement.Face();
                                    Me.CurrentTarget.Interact();
                                    Styx.Logic.Inventory.Frames.LootFrame.LootFrame.Instance.LootAll();
                                    if (lootTimer.ElapsedMilliseconds > 2500)
                                    {
                                        //slog("Blacklisting, could not loot");
                                        LootBlacklist.Add(Me.CurrentTarget);
                                        LootList.Clear();
                                        lootTimer.Stop();
                                        lootTimer.Reset();
                                        Me.ClearTarget();

                                    }
                                    Thread.Sleep(500);
                                }
                                else
                                {

                                    Navigator.MoveTo(Me.CurrentTarget.WorldLocation);
                                }
                            }
                            else if (!Me.CurrentTarget.CanLoot)
                            {

                                Me.ClearTarget();
                                lootTimer.Stop();
                            }
                        }
                    #endregion

                        #region Loot objects

                        foreach (WoWUnit Lootable in LootList)
                        {
                            //if (LootBlacklist.Contains(Lootable))
                            //{
                            //    Me.ClearTarget();
                            //    Thread.Sleep(500);
                            //}
                            if (Me.CurrentTarget == null)
                            {
                                Lootable.Target();
                                Thread.Sleep(500);
                            }
                            else if (Me.CurrentTarget.CanLoot && Me.CurrentTarget.Dead)
                            {
                                if (Me.CurrentTarget.WithinInteractRange)
                                {
                                    lootTimer.Start();
                                    islooting = true;
                                    WoWMovement.MoveStop();
                                    WoWMovement.Face();
                                    Me.CurrentTarget.Interact();
                                    Styx.Logic.Inventory.Frames.LootFrame.LootFrame.Instance.LootAll();
                                    //if (lootTimer.ElapsedMilliseconds > 5500)
                                    //{
                                    //    //slog("Blacklisting, could not loot");
                                    //    LootBlacklist.Add(Me.CurrentTarget);
                                    //    LootList.Clear();
                                    //    lootTimer.Stop();
                                    //    lootTimer.Reset();
                                    //    Me.ClearTarget();
                                    //    islooting = false;

                                    //}
                                    Thread.Sleep(500);
                                }
                                else
                                {

                                    Navigator.MoveTo(Me.CurrentTarget.WorldLocation);
                                    islooting = true;
                                }
                            }
                            else if (!Me.CurrentTarget.CanLoot)
                            {

                                Me.ClearTarget();
                                lootTimer.Stop();
                                islooting = false;
                            }

                        }
                        #endregion
                    }
                }

                //catch
                {
                }
            }
        }


        #endregion

        #region Populate Lists
        private void populate()
        {
            if (AutoQuestItem)
            {
                if (Skinning)
                {

                    if (NinjaSkin)
                    {
                        SkinList = ObjectManager.GetObjectsOfType<WoWUnit>()
                .Where(u => !u.IsAlive && u.CanSkin && u.Level <= Me.CanSkinLevel && u.Distance <= 35)
                .OrderBy(u => u.Distance).ToList();

                    }
                    else
                    {

                        SkinList = ObjectManager.GetObjectsOfType<WoWUnit>()
                .Where(u => !u.IsAlive && u.CanSkin && u.Level <= Me.CanSkinLevel && u.KilledByMe && u.Distance <= 35)
                .OrderBy(u => u.Distance).ToList();

                    }
                }

                LootList = ObjectManager.GetObjectsOfType<WoWUnit>()
            .Where(u => !u.IsAlive && u.CanLoot && u.Distance <= 35)
            .OrderBy(u => u.Distance).ToList();
            }
        }

        #endregion

        #region Misc Stuff
        private void timer()
        {
            if (lootTimer.ElapsedMilliseconds > 6000)
            {
                lootTimer.Reset();
                lootTimer.Start();
            }
        }
        private static int randnum(int min, int max)
        {
            Random random = new Random();
            return random.Next(min, max);
        }
        #endregion

        #region Select Leader
        private void selleader()
        {




            if (FirstPulse)
            {

                if (!ManLeadFound && ManualLeader)
                {
                    slog("****************************************");
                    slog("Manual Leader selection enabled, please target the player you wish to be leader, you have 10 seconds");
                    slog("****************************************");
                    Thread.Sleep(10000);

                    if (Me.CurrentTarget.IsPlayer)
                    {

                        slog("Current Target is " + Me.CurrentTarget.Name + ", attempting to set as leader");
                        Leader = Me.CurrentTarget.ToPlayer();

                    }
                }
                else if (!ManualLeader)
                    try
                    {


                        Leader = Me.PartyMember1;

                    }
                    catch
                    {
                    }


                try
                {

                    {
                        if (!ManLeadFound)
                        {
                            slog("Setting Leader to " + Leader.Name);
                            ManLeadFound = true;
                        }
                        RaFHelper.SetLeader(Leader);
                        FirstPulse = false;

                    }
                }
                catch
                {
                }
            }
        }





        #endregion

        #region Movement Logic
        private void movement()
        {
            try
            {
                if (!RaFHelper.Leader.IsOutOfBounds)
                {
                    //try
                    {
                        #region Mount logic
                        //Mount Check

                        if (RaFHelper.Leader.Mounted && !Me.Mounted && (!Me.IsInInstance || !Me.IsIndoors))
                        {
                            Lua.DoString("RunMacro('Mount')");
                            slog(RaFHelper.Leader.Name + " has mounted, mounting " + LevelbotSettings.Instance.MountName);
                            //Mount.MountUp();
                            Thread.Sleep(2000);
                        }

                        if (!RaFHelper.Leader.Mounted && Me.Mounted)
                        {
                            if (Me.IsFlying)
                            {
                                slog("Leader has dismounted, but im still flying, coming in for a landing");
                                if (RaFHelper.Leader.Distance < 10)
                                {
                                    Mount.Dismount();
                                }
                            }
                            else
                            {
                                slog(RaFHelper.Leader.Name + " has dismounted, dismounting");
                                Mount.Dismount();
                                WoWPoint movePoint = WoWMovement.CalculatePointFrom(RaFHelper.Leader.WorldLocation, distance_to_follow);
                                Navigator.MoveTo(movePoint);
                            }
                        }
                        if (RaFHelper.Leader.IsFlying && RaFHelper.Leader.Mounted && Me.Mounted && RaFHelper.Leader.Distance <= 25)
                        {
                            RaFHelper.Leader.Target();
                            if (!Me.IsFlying)
                            {
                                slog("Leader appears to be flying, attempting to follow");
                            }
                            Lua.DoString("FollowUnit(" + ")");

                            Thread.Sleep(1000);
                        }
                        else if (RaFHelper.Leader.IsFlying && RaFHelper.Leader.Mounted && Me.Mounted && RaFHelper.Leader.Distance > 25)
                        {
                            slog("Flying leader is to far away, Come Back!");
                        }

                        #endregion

                        #region Loot Start
                        //Begin's loot routine if needed
                        if (lootatall)
                        {
                            if (!RaFHelper.Leader.Combat && RaFHelper.Leader.IsAlive && !Me.Combat && !Me.NormalBagsFull )
                            {
                                if (!Me.IsInInstance && !Me.IsIndoors || Me.IsInInstance && lootininstance || Me.IsIndoors && lootinside)
                                {
                                    Loot();
                                }
                            }
                        }

                        #endregion



                        if ((QuestItems.Count == 0 && !QuestGiverTargeted && LootList.Count == 0 && SkinList.Count == 0 || Me.NormalBagsFull ) && RaFHelper.Leader.IsAlive && Me.IsAlive && !RaFHelper.Leader.Combat && !Me.Combat && !RaFHelper.Leader.IsFlying && RaFHelper.Leader.Distance > distance_to_follow)
                        {
                            WoWPoint movePoint = WoWMovement.CalculatePointFrom(RaFHelper.Leader.WorldLocation, distance_to_follow);
                            Navigator.MoveTo(movePoint);
                        }
                    }
                    // catch
                    {
                        //     slog("Appears we are having an issue with the leader, attempting to relocate");

                        //    FirstPulse = true;
                        //    Thread.Sleep(5000);
                        //    selleader();

                    }
                }
            }
            catch
            {
                FirstPulse = true;
            }


        }
        #endregion

        #region Combat
        private void combat()
        {
            try
            {
                if (RaFHelper.Leader.IsValid)
                {
                    if (RaFHelper.Leader.Combat || RaFHelper.Leader.Combat && RaFHelper.Leader.GotAlivePet && pettarget)

                    //if (RaFHelper.Leader.CurrentTarget != null && Me.CurrentTarget != RaFHelper.Leader.CurrentTarget || Me.CurrentTarget != RaFHelper.Leader.Pet.CurrentTarget)
                    {
                        //if (RaFHelper.Leader.CurrentTarget != null)
                        //{
                        if (RaFHelper.Leader.CurrentTarget != null)
                        {
                            RaFHelper.Leader.CurrentTarget.Target();
                        }
                        if (pettarget && RaFHelper.Leader.GotAlivePet)
                        {
                            if (RaFHelper.Leader.CurrentTarget == null && RaFHelper.Leader.Pet.CurrentTarget != null)
                            {
                                RaFHelper.Leader.Pet.CurrentTarget.Target();
                            }
                        }
                        if (!Me.Combat)
                        {
                            if (RaFHelper.Leader.CurrentTarget != null && (!Me.IsCasting || !Me.IsAutoAttacking))
                            {
                                TreeRoot.StatusText = RaFHelper.Leader.Name + " is attacking " + RaFHelper.Leader.CurrentTarget.Name + ", helping out!";
                            }
                            else if (pettarget && !Me.IsCasting && RaFHelper.Leader.GotAlivePet && RaFHelper.Leader.CurrentTarget == null && RaFHelper.Leader.Pet.CurrentTarget != null)
                            {
                                TreeRoot.StatusText = RaFHelper.Leader.Name + "' pet " + RaFHelper.Leader.Pet.Name + " is attacking " + RaFHelper.Leader.Pet.CurrentTarget.Name + ", helping out!";
                            }
                        }
                    }
                    //}

                    //}
                }
            }
            catch
            {
            }
        }

        #endregion

        #region Target RaFHelper's Target is Questgiver/taker
        private void TargetRafQGT()
        {

            try
            {
                if (AutoTargetQG && RaFHelper.Leader.CurrentTarget != null)
                {
                    if (RaFHelper.Leader.CurrentTarget.QuestGiverStatus == QuestGiverStatus.TurnIn || RaFHelper.Leader.CurrentTarget.QuestGiverStatus == QuestGiverStatus.Available || RaFHelper.Leader.CurrentTarget.QuestGiverStatus == QuestGiverStatus.AvailableRepeatable || RaFHelper.Leader.CurrentTarget.QuestGiverStatus == QuestGiverStatus.TurnInRepeatable || RaFHelper.Leader.CurrentTarget.InteractType == WoWInteractType.TaxiPathAvailable)
                    {
                        QuestGiverTargeted = true;
                        if (Me.CurrentTarget != RaFHelper.Leader.CurrentTarget)
                        {
                            RaFHelper.Leader.CurrentTarget.Target();
                        }
                        else
                        {
                            if (Me.CurrentTarget.WithinInteractRange)
                            {
                                WoWMovement.MoveStop();
                                Me.CurrentTarget.Interact();
                            }
                            else
                            {
                                Navigator.MoveTo(Me.CurrentTarget.WorldLocation);
                            }

                        }

                    }
                    else
                    {
                        if (QuestGiverTargeted)
                        {
                            Me.ClearTarget();
                            QuestGiverTargeted = false;
                        }
                    }
                }
            }
            catch
            {
            }
        }
        #endregion

        #region Death Code
        private void IsDead()
        {
            if (Me.Dead)
            {
                Lua.DoString("RepopMe()");
            }

            if (Me.IsGhost)
            {
                if (Battlegrounds.IsInsideBattleground)
                {
                    slog("Waiting for spirit rez");
                }
                else
                {
                    Navigator.MoveTo(Me.CorpsePoint);
                    try
                    {
                        {
                            if (!RaFHelper.Leader.Dead && !RaFHelper.Leader.IsGhost)
                            {
                                Lua.DoString("RetrieveCorpse()");
                            }
                        }
                    }
                    catch
                    {
                        FirstPulse = true;
                        //    slog("Error in Death Code");
                        selleader();

                    }
                }
            }

        }

        #endregion

        public override void Pulse()
        {

            if (!Me.Combat && !FirstPulse)
            {
                TargetRafQGT();
            }
            populate();
            if (!verann)
            {
                slog("Multibox Follower version 3.9.6");
                verann = true;
            }

            {

                if (RoutineManager.Current.NeedRest && !Me.Dead && !Me.IsGhost)
                {
                    slog("CC Says we need rest Letting it do it.");
                    RoutineManager.Current.Rest();
                }
                else
                {
                    if (!Me.IsInParty)
                    {
                        slog("Not in party, please rectify this situation");
                    }
                    else
                    {



                        selleader();


                        if (Me.IsGhost || Me.Dead)
                        {
                            IsDead();
                        }
                        else
                        {


                            movement();


                            combat();
                        }


                    }
                }
            }
            //catch
            //{
            //    slog("Error in pulse");
            //    selleader();
            //}
        }
        #endregion

        #region Behaviors

        #region Combat Behavior




        private static bool NeedPull(object context)
        {
            var target = StyxWoW.Me.CurrentTarget;

            if (target == null)
                return false;

            if (!target.InLineOfSight)
                return false;

            if (target.Distance > Targeting.PullDistance)
                return false;

            return true;
        }

        private static Composite CreateCombatBehavior()
        {
            return new PrioritySelector(

                new Decorator(ret => !StyxWoW.Me.Combat && !StyxWoW.Me.Dead && !StyxWoW.Me.IsGhost,
                    new PrioritySelector(


            #region PreCombatBuffs

new PrioritySelector(
                // new ActionDebugString("[Combat] Checking PCBBehavior"),
                // Use the bt
                            new Decorator(ctx => RoutineManager.Current.PreCombatBuffBehavior != null,
                                RoutineManager.Current.PreCombatBuffBehavior),

                            // don't use the bt
                // new ActionDebugString("[Combat] Checking PCBOld"),
                            new Decorator(
                                ctx => RoutineManager.Current.NeedPreCombatBuffs,
                                new Sequence(
                                    new Action(ret => TreeRoot.StatusText = "Applying pre-combat buffs"),
                                    new Action(ret => RoutineManager.Current.PreCombatBuff())
                                    ))),

            #endregion

            #region Pull

                // new ActionDebugString("[Combat] Pull"),
                // Don't pull, unless we've decided to pull already.
                        new Decorator(ret => BotPoi.Current.Type == PoiType.Kill,
                            new PrioritySelector(

                                // Make sure we have a valid target list.
                                new Decorator(ret => Targeting.Instance.TargetList.Count != 0,
                // Force the 'correct' POI to be our target.
                                    new Decorator(ret => BotPoi.Current.AsObject != Targeting.Instance.FirstUnit &&
                                        BotPoi.Current.Type == PoiType.Kill,
                                        new Sequence(

                                            new Action(ret => BotPoi.Current = new BotPoi(Targeting.Instance.FirstUnit, PoiType.Kill)),
                                            new Action(ret => BotPoi.Current.AsObject.ToUnit().Target())))),

                                        new Decorator(NeedPull,
                                            new PrioritySelector(
                                                new Decorator(ctx => RoutineManager.Current.PullBuffBehavior != null,
                                                    RoutineManager.Current.PullBuffBehavior),

                                                new Decorator(ctx => RoutineManager.Current.PullBehavior != null,
                                                    RoutineManager.Current.PullBehavior),

                                                    new ActionPull())))))),
            #endregion

 new Decorator(ret => StyxWoW.Me.Combat,

                    new PrioritySelector(

            #region Heal

new PrioritySelector(
                // Use the Behavior
                            new Decorator(ctx => RoutineManager.Current.HealBehavior != null,
                                new Sequence(
                                    RoutineManager.Current.HealBehavior,
                                    new Action(delegate { return RunStatus.Success; })
                                    )),

                            // Don't use the Behavior
                            new Decorator(ctx => RoutineManager.Current.NeedHeal,
                                new Sequence(
                                    new Action(ret => TreeRoot.StatusText = "Healing"),
                                    new Action(ret => RoutineManager.Current.Heal())
                                    ))),

            #endregion

            #region Combat Buffs

 new PrioritySelector(
                // Use the Behavior
                            new Decorator(ctx => RoutineManager.Current.CombatBuffBehavior != null,
                                        new Sequence(
                                            RoutineManager.Current.CombatBuffBehavior,
                                            new Action(delegate { return RunStatus.Success; })
                                            )
                                ),

                            // Don't use the Behavior
                            new Decorator(ctx => RoutineManager.Current.NeedCombatBuffs,
                                        new Sequence(
                                            new Action(ret => TreeRoot.StatusText = "Applying Combat Buffs"),
                                            new Action(ret => RoutineManager.Current.CombatBuff())
                                            ))),

            #endregion

            #region Combat

 new PrioritySelector(
                // Use the Behavior
                            new Decorator(ctx => RoutineManager.Current.CombatBehavior != null,
                                new PrioritySelector(
                                    RoutineManager.Current.CombatBehavior,
                                    new Action(delegate { return RunStatus.Success; })
                                    )),

                            // Don't use the Behavior
                            new Sequence(
                                new Action(ret => TreeRoot.StatusText = "Combat"),
                                new Action(ret => RoutineManager.Current.Combat())))

            #endregion

)),

              new Decorator(delegate(object context) { try { return RaFHelper.Leader.IsValid; } catch { return false; } },
                new Decorator(ret => !StyxWoW.Me.Dead && !StyxWoW.Me.IsGhost && RaFHelper.Leader.Combat,

                    new PrioritySelector(

            #region Heal

new PrioritySelector(
                // Use the Behavior
                            new Decorator(ctx => RoutineManager.Current.HealBehavior != null,
                                new Sequence(
                                    RoutineManager.Current.HealBehavior,
                                    new Action(delegate { return RunStatus.Success; })
                                    )),

                            // Don't use the Behavior
                            new Decorator(ctx => RoutineManager.Current.NeedHeal,
                                new Sequence(
                                    new Action(ret => TreeRoot.StatusText = "Healing"),
                                    new Action(ret => RoutineManager.Current.Heal())
                                    ))),

            #endregion

            #region Combat Buffs

 new PrioritySelector(
                // Use the Behavior
                            new Decorator(ctx => RoutineManager.Current.CombatBuffBehavior != null,
                                        new Sequence(
                                            RoutineManager.Current.CombatBuffBehavior,
                                            new Action(delegate { return RunStatus.Success; })
                                            )
                                ),

                            // Don't use the Behavior
                            new Decorator(ctx => RoutineManager.Current.NeedCombatBuffs,
                                        new Sequence(
                                            new Action(ret => TreeRoot.StatusText = "Applying Combat Buffs"),
                                            new Action(ret => RoutineManager.Current.CombatBuff())
                                            ))),

            #endregion

            #region Combat

 new PrioritySelector(
                // Use the Behavior
                            new Decorator(ctx => RoutineManager.Current.CombatBehavior != null,
                                new PrioritySelector(
                                    RoutineManager.Current.CombatBehavior,
                                    new Action(delegate { return RunStatus.Success; })
                                    )),

                            // Don't use the Behavior
                            new Sequence(
                                new Action(ret => TreeRoot.StatusText = "Combat"),
                                new Action(ret => RoutineManager.Current.Combat())))

            #endregion

))));
        }

        #endregion



        #endregion
    }
}
